;	d0=start cylinder
;	d1=no. of cylinders to read
;	d2=load address to be outputed in to.
; HEADOUT = towards cylinder # 0
; HEADIN  = towards cylinder # 80

org	$20000
load	$20000
s:	bsr	dl_seekTRK0

	moveq	#70,d0
	moveq	#10,d1
	move.l	#$40000,d2
	move	#$4000,$dff09a
	bsr	dl_start
	move	#$c000,$dff09a
	rts


DL_start:
	movem.l d0-d7/a0-a6,-(a7)
	bsr	DL_seektrack
	bsr	DL_setup
	bsr	DL_readboth
DL_load:			;read forward d0 amount of cylinders
	cmp	#1,d1
	beq.s	DL_setdown
	subq	#1,d1
	bsr	DL_headin
	bsr	DL_readboth	
	bra.s	DL_load

DL_setup:
	lea	DL_loadadr(pc),a0
	move.l	d2,(a0)
	move	$dff010,D0
	bset	#15,D0
	lea	DL_Uart(pc),a0
	move	D0,(a0)
	rts
DL_setdown:
	move.b	#$f9,D0
	move.b	D0,$bfd100
	and.b	DL_Dsk(pc),D0
	move.b	D0,$bfd100
	move	#$7fff,$dff09e
	move	DL_Uart(pc),$dff09e
	movem.l (a7)+,d0-d7/a0-a6
	rts
DL_readupper:
	bclr	#2,$bfd100
	bra.s DL_set
DL_readlower:
	bset	#2,$bfd100
	bra.s DL_set
DL_readboth:		;read & decode the current track
	bset	#2,$bfd100
	bsr.s	DL_set			; do side upper
	bclr	#2,$bfd100		; do side lower
DL_set: move	#$8210,$dff096
	move	#$7fff,$dff09e
	move	#$9500,$dff09e
	move	#$4489,$dff07e		;sync
	lea	DL_DSKpointer(pc),a0
	move.l	(a0),$dff020
	move	#$4000,$dff024
DL_ready:
	btst	#5,$bfe001
	bne.s	DL_ready
	move	#$9980,$dff024
	move	#$9980,$dff024
	move	#$0002,$dff09c
DL_ready2:
	btst	#1,$dff01f
	beq.s	DL_ready2
	move	#$4000,$dff024
	bsr	DL_Trackuncode
	lea	DL_Loadadr(pc),a0
	addi.l	#$1600,(a0)		;update output address
	rts

DL_drv: bset	#2,$bfd100

DL_HeadIN:				;position head to new track
	lea	DL_TRKno(pc),a0
	addq	#1,(a0)
	move.b	#%01111101,$bfd100
	move.b	#%01111100,D7
	and.b	-2(a0),D7
	bra.s	DL_sel
DL_HeadOUT:
	lea	DL_TRKno(pc),a0
	subq	#1,(a0)
	move.b	#%01111111,$bfd100
	move.b	#%01111110,D7
	and.b	-2(a0),D7
DL_sel:			;little delay for track shifting
			;must be done to tolorate
			;non-perfect drives
			;may work on goo quality drives (new-ones)
	mulu	#1,d0
	move.b	D7,$bfd100
	bset	#0,D7
	move.b	D7,$bfd100
	lea	dl_delayT(pc),a0
	move	(a0),D6		;delayloop for accurate Head Movement
DL_delay:
	nop
	dbra	D6,DL_delay
	rts
DL_delayT:
	dc.w $555

DL_seekTRK0:
	btst	#4,$bfe001	;position head at Cylinder 0
	beq.s	DL_trk0
	bsr.s	DL_HeadOUT
	bra.s	DL_seekTRK0
DL_trk0:clr	DL_TRKno	;write cyl pos
	rts

DL_seektrack:			;goto track d0
	lea	dl_trkno(pc),a0
	move	(a0),d3
	cmp	d3,d0
	beq.s	DL_seektrack-2	;do rts
	cmp	d3,d0
	ble.s	DL_seektrack2
	sub	d3,d0
	bra.s	DL_seekd0
DL_seektrack2:
	sub	d0,d3
	move	d3,d0
	bra.s	DL_backd0


DL_seekd0:			;goes Forward D0 amount of Cylinders
	tst	d0
	beq.s	DL_seekd0-2
DL_seekup:
	bsr	DL_HeadIN
	subq	#1,d0
	tst	d0
	bne.s	DL_seekup
	rts

DL_backd0:			;goes Backward D0 amount of Cylinders
	tst	d0
	beq.s	DL_backd0-2
DL_back:bsr	DL_HeadOUT
	subq	#1,d0
	tst	d0
	bne.s	DL_back
	rts

*------------------------------------

DL_Trackuncode:
	movem.l D0-D7/a0-a6,-(A7)
	move	#-1,DL_var
	moveq	#10,D6		;sectors 0 - 10
	move.l	DL_DSKpointer(pc),A0
	move.l	A0,A6
	add.l	#$3300,A6
DL_lp2:	cmp.l	A6,A0
	ble.s	DL_lp1
	movem.l (A7)+,D0-D7/a0-a6
	rts

DL_lp1:	cmp	#$4489,(A0)+	;wait for sync
	bne.s	DL_lp2
	cmp	#$4489,(A0)
	beq.s	DL_lp3
	bra.s	DL_lp4
DL_lp3:	addq.l	#2,A0
DL_lp4:	bsr.s	DL_uncode
	lea	DL_data(PC),A2
	move.b	2(A2),D1
	cmp.b	DL_var(pc),D1
	bne.s	DL_lp6
	addq.l	#8,A0
	bra.s	DL_lp2

DL_lp6:	lea	dl_var(pc),a3
	move.b	D1,(a3)
	and.l	#$ff,D1
	mulu	#$200,D1
	add.l	DL_Loadadr(pc),D1
	move.l	D1,A1
	add.l	#$38,A0
	move.l	A0,A2
	add.l	#$200,A2
	move	#$7f,D0

DL_cp1:	move.l	#$55555555,d3
DL_cp1a:move.l	(A0)+,D1	;read 1st half
	move.l	(A2)+,D2	;read 2nd half
	and.l	d3,d1		;AND odd bits of both55,D1
	and.l	d3,d2
	asl.l	#1,D1		;rotate 1st half
	or.l	D1,D2		;and merge both halfs together
	move.l	D2,(A1)+	; then write to buffer
	dbf	D0,DL_cp1a	;do 1 longword 128 times (ie 512 bytes)1
	dbf	D6,DL_lp2	;do 11 times for 11 sectors2
	movem.l (A7)+,d0-d7/a0-a6	;restore regs..A0-A6/D0-D7
	rts			;and return back...

DL_uncode:
	movem.l D0-D7/a0-a6,-(A7)
	moveq	#$0f,D2
	move.l	#$55555555,d3
	lea	DL_data(PC),A1		;procedure here is the same
DL_uncodeLP:				;for the decoding
	move.l	(A0)+,D0		;what this does is
	move.l	(A0)+,D1		;decode the sector headers
	and.l	d3,d0			;(ie. the 1st 15 longwords
	and.l	d3,d1			;before the actual data
	asl.l	#1,D0			;It contains various things
	or.l	D0,D1			;like Track # Sector #
	move.l	D1,(A1)+		;and empty things for protection
	dbf	D2,DL_uncodeLP		;and check sums!!!!!........... 
	movem.l (A7)+,D0-D7/a0-a6
	rts

DL_data:	blk.l	20,0
DL_Loadadr:	dc.l	0
DL_DSKpointer:	dc.l	diskbuffer
DL_Uart:	dc.w	0
DL_DSK:		dc.b	%11110111,0
DL_TRKno:	dc.w	0
DL_var:		dc.w	$0600
diskbuffer:	blk.w	$1a00,0

